;
; lib_asmz.asm
;
; Copyright(c) 1994-2000 Particle
;
; Assembler module for the Z compiler.
; 

.model small
.stack 100h
.data

.code

public printnum
public getdec
public newline


printchar proc
        push    ax
        mov     ah,02h
        int     21h
        pop     ax
        ret
printchar endp

newline proc
        push    dx
        mov     dl,10
        call    printchar
        mov     dl,13
        call    printchar
        pop     dx
	  ret
newline endp


;;;;;;;;;;;;;;; MYPRINTDEC ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Program to print a SIGNED WORD-SIZED number, v0.2 
;; INPUT: AX=NUMBER TO BE PRINTED
;; OUTPUT: NOTHING
;; By: Alex S.  iparticle@yahoo.com
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
printnum proc
        pushf
        push    ax      ;save registers...
        push    bx
        push    cx
        push    dx
        mov     bx,10   ;dividing by 10 repeatedly to get the char
        cmp     ax,00h  ;is negative?
        jge     pos     ;dont print the neg sign if positive...
        push    ax      ;save ax, just to print a char
        mov     ah,02h
        mov     dl,'-'  ;print the minus sign
        int     21h
        pop     ax      ;restore ax
        neg     ax      ;negate AX (make it positive)
pos:    xor     cx,cx   ;clear the counter (number of characters)
divide: xor     dx,dx   ;zero out dx for result...
        div     bx      ;divide by 10...
        push    dx      ;the remander goes onto stack...
        inc     cx      ;increase number of chars on stack...
        cmp     ax,0    ;did we devide enough to get to a zero?
        jne     divide  ;if not divide again...
        mov     ah,02h  ;print char
outch:  pop     dx      ;restore number from stack
        add     dl,'0'  ;convert number to character...
        int     21h     ;DOS service... (print char in dl)
        loop    outch   ;LOOP untill we get all from stack (CX)
        pop     dx      ;restore everything we used...
        pop     cx
        pop     bx
        pop     ax
        popf
        ret             ;get out...
printnum endp



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; printnum v1.9 by Particle                                   ;;
;; function to print a positive number...                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;base    equ     10              ;set the base of number to be printed
;printnum       proc
;        push    cx              ;save registers used... (very important)
;        push    dx
;        push    ax
;        mov     cx,base         ;can set the base of a number to anything
;        xor     dx,dx           ;for now, only work with 16 bit numbers.
;        div     cx              ;need to use some register...
;        cmp     ax,0            ;if result of a division is zero...
;        je      done            ;are we done?
;        call    printnum        ;if not, go again...
;done:   add     dl,'0'          ;convert number to character
;        mov     ah,02h          ;print to standard output
;        int     21h             ;dos service
;        pop     ax              ;pop all we have pushed
;        pop     dx
;        pop     cx
;        ret                     ;get out of here...
;printnum        endp
;

;; function to read in an ineger value and return it in AX
getdec proc    near
        pushf           ;save flags...
        push    cx      ;save registers...
        push    bx
        push    dx      ;save it because of mul...
        push    bp
        xor     bx,bx   ;clear bx...
        xor     bp,bp   ; the default is positive...
        mov     ah,01h  ;read character...
        int     21h     ;dos service...
        cmp     al,'+'  ;check for nerds who type '+' in a number
        jz      getch2  ;just continue if '+', the default...
        cmp     al,'-'  ;is negative?
        jne     check   ;if the first number is not '+' nor '-'  
        mov     bp,1    ;flag the negative...
getch:  mov     ah,01h  ;read character
getch2: int     21h
check:  cmp     al,'0'  ;check if the number is a valid number
        jl      ExitD
        cmp     al,'9'
        jg      ExitD
        sub     al,'0'  ;convert sysbol in al to number (0-9)
        cbw             ;clear out ah...
        mov     cx,ax   ;save number...
        mov     ax,10   ;10 * number (move the number one position to 
        mul     bx      ;the left to make room for the new number(0-9).
        add     ax,cx   ;add the character to the number (add 0-9)...
        mov     bx,ax   ;save the number for later multiplication.
        jmp     getch   ;go get another number...
ExitD:  mov     ax,bx   ;return the number in ax
        cmp     bp,1    ;check sign...
        jne     FinD
        neg     ax      ;if negative then negate...
FinD:   pop     bp
        pop     dx
        pop     bx      ;restore changed registers exept for ax
        pop     cx
        popf
        ret
getdec endp

end



