/*
 * namevalue.h
 *
 * Copyright(c) 1999, Particle
 */

#ifndef _NAMEVALUE_H_
#define _NAMEVALUE_H_

typedef struct namevalue_s{
	char* name;
	char* value;
	struct namevalue_s* next;
}namevalue_t;

/*
 * creates a new name value given a name and a value
 */
namevalue_t* createNameValue(char* name,char* value);

/*
 * adds a name & value to a list of name values. this method
 * can also be used to create name values by passing a null list
 */
namevalue_t* addNameValue(namevalue_t* l,char* name,char* value);

/*
 * this method makes sure that the name (in name value pair) is 
 * uniq in this namevalue list. it doesn't insert duplicates
 */
namevalue_t* addUniqNameValue(namevalue_t* l,char* name,char* value);


/*
 * frees name values 
 */
void freeNameValue(namevalue_t* l);

/*
 * tries to find a name value by name; returns name 
 * value with that name or null if not found.
 */
namevalue_t* findNameValueByName(namevalue_t* l,char* name);

/*
 * tries to find a name value by value; returns name 
 * value with that value or null if not found.
 */
namevalue_t* findNameValueByValue(namevalue_t* l,char* value);

#endif

