/*
 * nodes.c
 *
 * Copyright(c) 1999, Particle
 */

/*
    this module supports the parse tree
 */

#include <stdlib.h>

#include "scanner.h"

#include "nodes.h"


/*
 * creates a node given some parameters
 */
node_t* createNode(node_t* left,int type,node_t* right,token_t* token){
	node_t* node = (node_t*)malloc(sizeof(node_t));
	if(!node)
		error("cannot allocate %d bytes for node",sizeof(node_t));
	if(token)
		node->token = makeTokenFromToken(token);
	else
		node->token = 0;
	node->left = left;
	node->right = right;
	node->type = type;
	node->next = 0;
	return node;
}

/*
 * free node
 */
void freeNode(node_t* n){
	if(n){
		if(n->token)
			freeToken(n->token);
		freeNode(n->left);
		freeNode(n->right);
		freeNode(n->next);
		free(n);
	}
}


