/*
 * nodes.h
 *
 * Copyright(c) 2000, Particle
 */

#ifndef _NODES_H_
#define _NODES_H_

#define NODE_NAME 1
#define NODE_NUMBER 2
#define NODE_IF 3
#define NODE_WHILE 4

#define NODE_ADD 5
#define NODE_SUB 6
#define NODE_MUL 7
#define NODE_DIV 8
#define NODE_NEG 9
#define NODE_GT 10
#define NODE_LT 11
#define NODE_ASSIGN 12
#define NODE_BLOCK 13
#define NODE_LIST 14
#define NODE_PROGRAM 15
#define NODE_READ 16
#define NODE_WRITE 17

#define NODE_DEREFNAME 18

typedef struct node_s{

	int type;
	struct node_s* left;
	struct node_s* right;
	struct node_s* next;

	union{
		struct{
			int nval;
			char* sval;
		}val;
		struct node_s* cond;

	}u;

}node_t;

/*
 * creates a node given some parameters
 */
node_t* createNode(node_t* left,int type,node_t* right);

node_t* createNameNode(char* s);

node_t* createNumberNode(int n);

node_t* createIfNode(node_t* iftrue,node_t* iffalse,node_t* cond);

node_t* createWhileNode(node_t* iftrue,node_t* cond);

/*
 * free node
 */
void freeNode(node_t* n);


#endif