/*
 * nutn.c
 *
 * Copyright(c) 1998-1999, Particle
 */

#include <stdio.h>

#include "error.h"
#include "files.h"
#include "scanner.h"
#include "parser.h"
#include "nodes.h"

#include "gen_asm_z.h"

void nutn(parser_t* parser,FILE* output){
		/* get first token */
	node_t* root = 0;

	root = parse_program(parser);

	gen_asm(root,output);

	freeNode(root);
}

int main(int argc,char** argv,char** env){

	parser_t* parser = 0;

	if(argc < 2)
		error("usage: %s [infile]",argv[0]);

	parser = createParserFromFile(argv[1]);

	nutn(parser,stdout);

	/* free memory allocated by fileLoad() */
	freeParser(parser);

	return 0;
}

