/*
 * scanner_z.c
 *
 * Copyright(c) 1999, Particle
 */

#include <ctype.h>

#include "scanner.h"
#include "error.h"

/* custom readToken for Z language */
token_t* readToken(scanner_t* scanner){
	enum {one,two,three,four} state = one;

	int i;

	int start,end;
	start = end = 0;

	if(!scanner)
		error("null parameter to readToken()");
	else if(scanner->where >= scanner->length)
		return 0;

	for(i = scanner->where;state != four && i < scanner->length;i++){
		char ch = scanner->buffer[i];

		if(ch == '\n')
			scanner->lineno++;

		if(state == one){
			if(isalpha(ch)){
				state = two;
				start = i;
			}else if(isdigit(ch)){
				state = three;
				start = i;
			}else if(ch == '(' || ch == ')' || ch == '+' || ch == '-' ||
				ch == '*' || ch == '/' || ch == '=' || ch == ';' ||
				ch == '{' || ch == '}' || ch == '>' || ch == '<'){
				start = end = i;
				state = four;
			}
		}else if(state == two){
			if(!isalnum(ch)){
				state = four;
				end = i-1;
			}
		}else if(state == three){
			if(!isdigit(ch)){
				state = four;
				end = i-1;
			}
		}
	}

	if(state != four){
		if(start == 0 && end == 0){
			scanner->where = scanner->length;
			return 0;
		}
		end = scanner->length - 1;
	}
	scanner->where = end + 1;

	return makeToken(scanner->buffer,start,end);
}


