%{

/*
 * z lexer
 *
 * Copyright(c) 2000, Particle
 */

#include <stdio.h>
#include <stdlib.h>

#include "nodes.h"
#include "y.tab.h"

%}

name [A-Za-z]+
number [0-9]+

%%

"if" { return IF; }
"else" { return ELSE; }
"while" { return WHILE; }
"read" { return READ; }
"write" { return WRITE; }

{name} { 	  
		char* s = (char*)malloc(strlen(yytext)+1);
		if(!s)
			error("not enough memory for token: %s\n",yytext);
		strcpy(s,yytext);
		yylval.sval = s;
		return NAME;
	}

{number} { yylval.nval = atoi(yytext); 
		return NUMBER;
		}
[ \n\t]+

.	{ return yytext[0]; }

%%


int yywrap(){
	return 1;
}

void yyerror(char* s){
	printf("(%d): %s: %s\n",yylineno,yytext,s);

}